---
title: Device-Memory
slug: Web/HTTP/Headers/Device-Memory
tags:
  - Client hints
  - Device Memory API
  - HTTP
  - HTTP Header
---
<div>{{HTTPSidebar}}{{securecontext_header}}{{SeeCompatTable}}</div>

<p>The <strong><code>Device-Memory</code></strong> header is a <a href="/en-US/docs/Web/API/Device_Memory_API">Device Memory API</a> header that works like <a href="/en-US/docs/Glossary/Client_hints">Client Hints</a> header which represents the approximate amount of RAM client device has.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Request header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>?</td>
  </tr>
 </tbody>
</table>

<div class="notecard note">
<p><strong>Note:</strong> Client Hints are accessible only on secure origins (via TLS). Server has to opt in to receive <code>Device-Memory</code> header from the client by sending {{HTTPHeader("Accept-CH")}} and {{HTTPHeader("Accept-CH-Lifetime")}} response headers.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<p>The amount of device RAM can be used as a fingerprinting variable, so values for the header are intentionally coarse to reduce the potential for its misuse. The header takes on the following values: <code>0.25</code>, <code>0.5</code>, <code>1</code>, <code>2</code>, <code>4</code>, <code>8</code>.</p>

<pre class="syntaxbox notranslate">Device-Memory: &lt;number&gt;
</pre>

<h2 id="Examples">Examples</h2>

<p>Server first needs to opt in to receive <code>Device-Memory</code> header by sending the response headers {{HTTPHeader("Accept-CH")}} containing <code>Device-Memory</code> and {{HTTPHeader("Accept-CH-Lifetime")}}.</p>

<pre class="notranslate">Accept-CH: Device-Memory
Accept-CH-Lifetime: 86400
</pre>

<p>Then on subsequent requests the client might send <code>Device-Memory</code> header back:</p>

<pre class="notranslate">Device-Memory: 1
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Device Memory","#sec-device-memory-client-hint-header","Device-Memory")}}</td>
   <td>{{Spec2('Device Memory')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.Device-Memory")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Device_Memory_API">Device Memory API</a></li>
 <li>{{HTTPHeader("Accept-CH")}}</li>
 <li>{{HTTPHeader("Accept-CH-Lifetime")}}</li>
 <li>{{HTTPHeader("Vary")}}</li>
 <li>{{DOMxRef("Navigator.deviceMemory")}}</li>
</ul>
